| Version: 3.3.1

Public Member Functions | List of all members
wxPowerEvent Class Reference
Class List by Category » Events

`#include <wx/power.h>`

Inheritance diagram for wxPowerEvent:
[legend]

## Detailed Description

The power events are generated when the system power state changes, e.g.

the system is suspended, hibernated, plugged into or unplugged from the wall socket and so on. wxPowerEvents are emitted by wxWindows.

Notice that currently these events are generated only under MSW and Linux and that under Linux you must use wxPowerResource::Acquire() to receive them, e.g. typically an application interested in these events should initialize wxPowerResourceBlocker for wxPOWER_RESOURCE_SYSTEM resource using wxPOWER_DELAY block kind when initializing either the application itself or its main window. E.g. for an application that wants to handle suspend to gracefully close the open network connections and then reopen them on resume you could do

class MyMainFrame : public wxFrame
{
...
private:
wxPowerResourceBlocker m_powerDelaySleep;
};
MyMainFrame::MyMainFrame()
: wxFrame(...),
m_powerDelaySleep(wxPOWER_RESOURCE_SYSTEM,
"MyApp needs to close network connections",
wxPOWER_DELAY)
{
Bind(wxEVT_POWER_SUSPENDED, [](wxPowerEvent&) {
// Close network connections here.
});
Bind(wxEVT_POWER_RESUME, [](wxPowerEvent&) {
// Restore previously closed network connections here.
});
}
wxFrame
A frame is a window whose size and position can (usually) be changed by the user.
Definition: frame.h:166
wxPowerEvent
The power events are generated when the system power state changes, e.g.
Definition: power.h:139
wxPowerResourceBlocker
Helper RAII class ensuring that power resources are released.
Definition: power.h:272
wxEVT_POWER_RESUME
wxEventType wxEVT_POWER_RESUME
Definition: power.h:159
wxPOWER_DELAY
@ wxPOWER_DELAY
Delay suspend until the application handles the corresponding event.
Definition: power.h:59
wxPOWER_RESOURCE_SYSTEM
@ wxPOWER_RESOURCE_SYSTEM
Use to prevent automatic system suspend.
Definition: power.h:35
wxEVT_POWER_SUSPENDED
wxEventType wxEVT_POWER_SUSPENDED
Definition: power.h:157

To avoid the need to change the code using this event later when these events are implemented on the other platforms please use the test `ifdef wxHAS_POWER_EVENTS` instead of directly testing for the platform in your code: this symbol will be defined for all platforms supporting the power events.

## Events using this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxPowerEvent& event)

Event macros:

- EVT_POWER_SUSPENDING(func):
  Warning
    This event and the possibility to veto suspend was removed from MSW systems starting from Windows Vista. wxPowerResourceBlocker can be used to prevent the system from suspending under both XP and later systems, use it instead of handling this event.
  System is about to be suspended, this event can be vetoed to prevent suspend from taking place.
- EVT_POWER_SUSPENDED(func):
  System is about to suspend: normally the application should quickly (i.e. without user intervention) close all the open files and network connections here, possibly remembering them to reopen them later when the system is resumed.
- EVT_POWER_SUSPEND_CANCEL(func):
  Warning
    This event is currently never generated.
  System suspension was cancelled because some application vetoed it.
- EVT_POWER_RESUME(func):
  System resumed from suspend: normally the application should restore the state in which it had been before the suspension.

##

Library: wxCore
Category: Events

See also
  wxGetPowerType(), wxGetBatteryState()

## Public Member Functions
| wxPowerEvent ()
| wxPowerEvent (wxEventType evtType)
void | Veto ()
| Call this to prevent suspend from taking place in `wxEVT_POWER_SUSPENDING` handler (it is ignored for all the others). More...
bool | IsVetoed () const
| Returns whether Veto has been called. More...
Public Member Functions inherited from wxEvent
| wxEvent (int id=0, wxEventType eventType=wxEVT_NULL)
| Constructor. More...
virtual wxEvent * | Clone () const =0
| Returns a copy of the event. More...
wxObject * | GetEventObject () const
| Returns the object (usually a window) associated with the event, if any. More...
wxEventType | GetEventType () const
| Returns the identifier of the given event type, such as `wxEVT_BUTTON`. More...
virtual wxEventCategory | GetEventCategory () const
| Returns a generic category for this event. More...
int | GetId () const
| Returns the identifier associated with this event, such as a button command id. More...
wxObject * | GetEventUserData () const
| Return the user data associated with a dynamically connected event handler. More...
bool | GetSkipped () const
| Returns true if the event handler should be skipped, false otherwise. More...
long | GetTimestamp () const
| Gets the timestamp for the event. More...
bool | IsCommandEvent () const
| Returns true if the event is or is derived from wxCommandEvent else it returns false. More...
void | ResumePropagation (int propagationLevel)
| Sets the propagation level to the given value (for example returned from an earlier call to wxEvent::StopPropagation). More...
void | SetEventObject (wxObject *object)
| Sets the originating object. More...
void | SetEventType (wxEventType type)
| Sets the event type. More...
void | SetId (int id)
| Sets the identifier associated with this event, such as a button command id. More...
void | SetTimestamp (long timeStamp=0)
| Sets the timestamp for the event. More...
bool | ShouldPropagate () const
| Test if this event should be propagated or not, i.e. if the propagation level is currently greater than 0. More...
void | Skip (bool skip=true)
| This method can be used inside an event handler to control whether further event handlers bound to this event will be called after the current one returns. More...
int | StopPropagation ()
| Stop the event from propagating to its parent window. More...
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to nullptr the internal reference data. More...
| wxObject (const wxObject &other)
| Copy ctor. More...
virtual | ~wxObject ()
| Destructor. More...
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar). More...
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object. More...
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class. More...
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj. More...
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone. More...
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer. More...
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data. More...
void | UnShare ()
| This is the same of AllocExclusive() but this method is public. More...
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined. More...
void * | operator new (size_t size, const wxString &filename=nullptr, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined. More...

## Additional Inherited Members
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object. More...
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it. More...
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data. More...
Protected Attributes inherited from wxEvent
int | m_propagationLevel
| Indicates how many levels the event can propagate. More...
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data. More...

## Constructor & Destructor Documentation

## ◆ wxPowerEvent() [1/2]

wxPowerEvent::wxPowerEvent | ( |  | ) |

## ◆ wxPowerEvent() [2/2]

wxPowerEvent::wxPowerEvent | ( | wxEventType | evtType | ) |

## Member Function Documentation

## ◆ IsVetoed()

bool wxPowerEvent::IsVetoed | ( |  | ) | const

Returns whether Veto has been called.

## ◆ Veto()

void wxPowerEvent::Veto | ( |  | ) |

Call this to prevent suspend from taking place in `wxEVT_POWER_SUSPENDING` handler (it is ignored for all the others).